:cherries: [@heap-data-structure/pairing-heap](https://heap-data-structure.github.io/pairing-heap)
==

<img src="https://cdn.rawgit.com/heap-data-structure/pairing-heap/main/media/sketch.svg" width="864">

Pairing heap data structure for JavaScript.
See [docs](https://heap-data-structure.github.io/pairing-heap/index.html).
Parent is [@heap-data-structure](https://github.com/heap-data-structure/about).

```js
import {increasing} from '@total-order/primitive';
import {PairingHeap} from '@heap-data-structure/pairing-heap';
let heap = new PairingHeap( increasing ) ;
```

[![License](https://img.shields.io/github/license/heap-data-structure/pairing-heap.svg)](https://raw.githubusercontent.com/heap-data-structure/pairing-heap/main/LICENSE)
[![Version](https://img.shields.io/npm/v/@heap-data-structure/pairing-heap.svg)](https://www.npmjs.org/package/@heap-data-structure/pairing-heap)
[![Tests](https://img.shields.io/github/workflow/status/heap-data-structure/pairing-heap/ci:test?event=push&label=tests)](https://github.com/heap-data-structure/pairing-heap/actions/workflows/ci:test.yml?query=branch:main)
[![Dependencies](https://img.shields.io/david/heap-data-structure/pairing-heap.svg)](https://david-dm.org/heap-data-structure/pairing-heap)
[![Dev dependencies](https://img.shields.io/david/dev/heap-data-structure/pairing-heap.svg)](https://david-dm.org/heap-data-structure/pairing-heap?type=dev)
[![GitHub issues](https://img.shields.io/github/issues/heap-data-structure/pairing-heap.svg)](https://github.com/heap-data-structure/pairing-heap/issues)
[![Downloads](https://img.shields.io/npm/dm/@heap-data-structure/pairing-heap.svg)](https://www.npmjs.org/package/@heap-data-structure/pairing-heap)

[![Code issues](https://img.shields.io/codeclimate/issues/heap-data-structure/pairing-heap.svg)](https://codeclimate.com/github/heap-data-structure/pairing-heap/issues)
[![Code maintainability](https://img.shields.io/codeclimate/maintainability/heap-data-structure/pairing-heap.svg)](https://codeclimate.com/github/heap-data-structure/pairing-heap/trends/churn)
[![Code coverage (cov)](https://img.shields.io/codecov/c/gh/heap-data-structure/pairing-heap/main.svg)](https://codecov.io/gh/heap-data-structure/pairing-heap)
[![Code technical debt](https://img.shields.io/codeclimate/tech-debt/heap-data-structure/pairing-heap.svg)](https://codeclimate.com/github/heap-data-structure/pairing-heap/trends/technical_debt)
[![Documentation](https://heap-data-structure.github.io/pairing-heap/badge.svg)](https://heap-data-structure.github.io/pairing-heap/source.html)
[![Package size](https://img.shields.io/bundlephobia/minzip/@heap-data-structure/pairing-heap)](https://bundlephobia.com/result?p=@heap-data-structure/pairing-heap)


## :scroll: References

  - [Improved bounds for multipass pairing heaps and path-balanced binary search trees](https://arxiv.org/abs/1806.08692)
